
/*
  Copyright (C) 2002-2005  Dmitry V. Levin <ldv@altlinux.org>

  client-server communications

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <stdio.h>
#include <errno.h>
#include <error.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "server.h"
#include "consolehelper.h"

IO_LOOP(write_loop, write, const)

ssize_t
write_client(const char *data, ssize_t len, int error_flag)
{
	ssize_t rc;

	if (error_flag && (rc = write_loop(CHILDOUT_FILENO, ":", 1)) != 1)
		return rc;

	return write_loop(CHILDOUT_FILENO, data, len);
}

char   *
read_client(void)
{
	char    buf[BUFSIZ];
	ssize_t count = read(CHILDIN_FILENO, buf, sizeof(buf) - 1);

	if (count < 0)
	{
		error(EXIT_SUCCESS, errno, "read_pass: read");
		return 0;
	}

	buf[count--] = '\0';
	if ((count > 0) && ('\n' == buf[count]))
		buf[count] = '\0';
	return strdup(buf);
}

void
close_client(void)
{
	close(CHILDIN_FILENO);
	close(CHILDOUT_FILENO);
}
