
/*
  Copyright (C) 2002  Dmitry V. Levin <ldv@altlinux.org>

  fds check

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <string.h>
#include <unistd.h>
#include <pwd.h>

const char *
get_logname(void)
{
	static const char *logname;

	if (!logname)
	{
		struct passwd *pw = 0;
		uid_t   uid = getuid();
		const char *user = getlogin();

		if (user)
		{
			pw = getpwnam(user);
			if (!pw || (pw->pw_uid != uid))
				pw = 0;
		}

		if (!pw)
			pw = getpwuid(uid);

		if (pw)
			logname = strdup(pw->pw_name);

		endpwent();
	}

	return logname;
}
