
/*
  Copyright (C) 2002, 2004  Dmitry V. Levin <ldv@altlinux.org>

  common server functions

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef CONSHELP_SERVER_H__
#define CONSHELP_SERVER_H__

#include <sys/types.h>

/* appconf */
typedef struct
{
	char   *const *argv;
	const char *user;
	const char *runas;
	const char *program;
	int     session;
}
appconf;
void    get_appconf(appconf * conf);

/* fds */
void    check_fds(void);
void    cleanup_fds(void);

/* logname */
const char *get_logname(void);

/* pam */
int     do_auth(const appconf * conf);

/* wait */
int     wait_for_child(pid_t child);

/* comm */
ssize_t write_client(const char *data, ssize_t len, int error_flag);
char   *read_client(void);
void    close_client(void);

#endif /* CONSHELP_SERVER_H__ */
